<template>
  <v-container>
    <v-data-iterator
      v-if="currentlyDataFiles.length !== 0"
      :items="currentlyDataFiles"
      disable-pagination
      hide-default-footer
      :loading="driveLoading"
    >
      <template v-slot:header>
        <v-row>
          <v-col>
            <span class="typeStyle caption darkness--text font-weight-medium">Arquivos:</span>
          </v-col>
        </v-row>
      </template>

      <!-- Begin Card Style -->
      <template v-slot:default="props">
        <v-row>
          <v-col v-for="(item, index) in props.items" :key="index" cols="2">
            <v-hover v-slot:default="{ hover }">
              <v-card class="v-card--hover" outlined>
                <!-- img -->
                <v-card-title class="subtitle-1 font-weight-bold justify-center">
                  <v-col cols="12" align="center">
                    <v-icon v-if="hover" :class="icons.basic.hover" x-large>
                      {{ icons[item.extension] ? icons[item.extension].icon : icons.basic.icon }}
                    </v-icon>
                    <v-icon
                      v-if="!hover"
                      :class="
                        icons[item.extension] ? icons[item.extension].color : icons.basic.color
                      "
                      x-large
                    >
                      {{ icons[item.extension] ? icons[item.extension].icon : icons.basic.icon }}
                    </v-icon>
                  </v-col>
                  <v-tooltip v-if="item.name.length >= 25" bottom color="primary">
                    <template v-slot:activator="{ on }">
                      <span v-on="on">{{ item.name.substring(0, 20) }}{{ item.extension }}</span>
                    </template>
                    <span>{{ item.name }}{{ item.extension }}</span>
                  </v-tooltip>

                  <span v-if="item.name.length < 25">{{ item.name }}{{ item.extension }}</span>
                </v-card-title>
                <v-card-subtitle v-if="!hover" class>
                  <v-icon class="iconOptionsCard white--text" small>mdi-pencil-outline</v-icon>
                </v-card-subtitle>
                <v-card-subtitle v-if="hover" align="center">
                  <!-- info button -->
                  <v-tooltip bottom color="primary">
                    <template v-slot:activator="{ on }">
                      <v-icon class="iconOptionsCard secondary--text" small v-on="on"
                        >mdi-information-outline</v-icon
                      >
                    </template>
                    <span v-if="item.size">Tamanho: {{ sizeToKb(item.size) }}{{ sizeFile }}</span>
                  </v-tooltip>

                  <!-- download button -->
                  <v-tooltip bottom color="primary">
                    <template v-slot:activator="{ on }">
                      <v-icon
                        class="iconOptionsCard secondary--text"
                        small
                        v-on="on"
                        @click="download(item)"
                        >mdi-download</v-icon
                      >
                    </template>
                    <span>Fazer Download</span>
                  </v-tooltip>

                  <!-- rename button -->
                  <v-tooltip bottom color="primary">
                    <template v-slot:activator="{ on }">
                      <v-icon
                        class="iconOptionsCard secondary--text"
                        small
                        v-on="on"
                        @click="rename(item)"
                        >mdi-pencil-outline</v-icon
                      >
                    </template>
                    <span>Renomear</span>
                  </v-tooltip>

                  <!-- delete button -->
                  <v-tooltip bottom color="primary">
                    <template v-slot:activator="{ on }">
                      <v-icon
                        class="iconOptionsCard secondary--text"
                        small
                        @click="nameOfItem(item)"
                        v-on="on"
                        >mdi-delete-outline</v-icon
                      >
                    </template>
                    <span>Deletar</span>
                  </v-tooltip>
                </v-card-subtitle>
              </v-card>
            </v-hover>
          </v-col>
        </v-row>
      </template>
      <!-- End Card Style -->
    </v-data-iterator>
  </v-container>
</template>

<script>
export default {
  props: {
    // eslint-disable-next-line vue/require-default-prop
    currentlyDataFiles: {
      type: Array,
    },
    driveLoading: {
      type: Boolean,
    },
  },
  data: () => ({
    sizeFile: '',
    overlay: false,
    icons: {
      basic: {
        icon: 'mdi-file',
        color: 'iconCard gray--text',
        hover: 'iconCard amber--text',
      },
      '.pdf': {
        icon: 'mdi-file-pdf-outline',
        color: 'iconCard red--text',
      },
      '.jpg': {
        icon: 'mdi-file-image-outline',
        color: 'iconCard green--text',
      },
      '.jpeg': {
        icon: 'mdi-file-image-outline',
        color: 'iconCard light-green--text',
      },
      '.png': {
        icon: 'mdi-file-image-outline',
        color: 'iconCard light-green--text',
      },
      '.doc': {
        icon: 'mdi-file-document-outline',
        color: 'iconCard light-blue--text',
      },
      '.docx': {
        icon: 'mdi-file-document-outline',
        color: 'iconCard light-blue--text',
      },
    },
    convertSize: '',
  }),

  created() {},
  methods: {
    nameOfItem(item) {
      this.$emit('itemToDelete', item)
    },
    rename(item) {
      this.$emit('itemToRename', item)
    },
    download(item) {
      this.$emit('download', item)
    },
    sizeToKb(bytes) {
      this.sizeFile = Math.floor(bytes / 1024) + ' KB'
    },
  },
}
</script>

<style>
.iconTitle {
  padding-right: 15px;
  padding-bottom: 5px;
}
.typeStyle {
  padding-left: 15px;
}

.nameFile {
  padding-bottom: 12px;
}

.iconCard {
  transform: scale(1.3);
}
.iconOptionsCard {
  padding-left: 3px;
  padding-right: 3px;
}
.v-card-file--reveal {
  bottom: -50px;
  opacity: 1;
  position: absolute;
  margin-left: 5%;
}
</style>
